% Compute prior mode
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%   Thermodynamically Consistent Bayesian Analysis    %%%%%%%%%%%
%%%%%%%%%%%       of Closed Biochemical Reaction Systems        %%%%%%%%%%%
%%%%%%%%%%%            Posterior Mode Rate Estimation           %%%%%%%%%%%
%%%%%%%%%%%         Authors: Jenkinson, Zhong, Goutsias         %%%%%%%%%%%
%%%%%%%%%%%              Last Modified: 11/04/2010              %%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%

function priorMode = findPriorMode(logkappa_0,tau,lambda) 

logkappa = (-40:0.005:20); 

for i = 1:size(logkappa,2)
    p(i) = exp(lambda^2/(2*tau^2))/(2*tau) ...
          *erfc((lambda/tau + (logkappa(i)-logkappa_0)/lambda)/sqrt(2)) ...
          *exp((logkappa(i)-logkappa_0)/tau);
end

priorMode = logkappa(find(p==max(p),1));